=begin
11_01_14
11 points instead of 6
in an horizontal plan only
following any direction
01_01_14
dimension between 6 points
following main axis
=end

require 'sketchup.rb'
#require 'inputbox'
require 'mult_dim_tool/inputbox'
	
module MCT

model = Sketchup.active_model # Open model

# Ajoute une ligne au menu
UI.menu("PlugIns").add_item("mult_dim_tool") { Sketchup.active_model.select_tool self::Cotation.new }

	
class Cotation

	def initialize
		#Declare vars
		@prem_point	#premier point
		@deux_point	#2e
		@trois_point #3e
		@quatre_point #4e
		@cinq_point #5e
		@six_point #6e
		@sept_point #7e
		@huit_point #8e
		@neuf_point #9e
		@dix_point #10
		@onze_point #11e
		@douze_point #12e		
		
	end#def
	
	def activate
		#Cotation is selected
		
		#Initialize input points
		@prem_point = Sketchup::InputPoint.new
		@deux_point = Sketchup::InputPoint.new
		@trois_point = Sketchup::InputPoint.new
		@quatre_point = Sketchup::InputPoint.new
		@cinq_point = Sketchup::InputPoint.new
		@six_point = Sketchup::InputPoint.new
		@sept_point = Sketchup::InputPoint.new
		@huit_point = Sketchup::InputPoint.new
		@neuf_point = Sketchup::InputPoint.new
		@dix_point = Sketchup::InputPoint.new
		@onze_point = Sketchup::InputPoint.new
		@douze_point = Sketchup::InputPoint.new		
		@ip = Sketchup::InputPoint.new
		
		
		#Reset state counter
		self.reset(nil)
	end#def

#	pour mettre un curseur special pendant l'operation	
#	def onSetCursor
#		cursor = UI.create_cursor(Sketchup.find_support_file("cursor.png", "Plugins/ene_3dRotate/"), 16, 14)
#		UI.set_cursor cursor
#	end#def

	def reset(view)
		#Clear input points
		@prem_point.clear
		@deux_point.clear
		@trois_point.clear
		@quatre_point.clear
		@cinq_point.clear
		@six_point.clear
		@sept_point.clear
		@huit_point.clear
		@neuf_point.clear
		@dix_point.clear
		@onze_point.clear
		@douze_point.clear
		
		#Point currently being selected
		@etat = 0
		
		#Status text for first input point
		#Status text is set as a class variable so it can be used in resume()
		@status_text = @hasSelection ? "clic on the..." : "1st point."

		Sketchup::set_status_text(@status_text, SB_PROMPT)
		
		
	end#def
	
	def onCancel(flag, view)
		#Reset tool when pressing ESC or reselecting it
		self.reset(view)
	end
	
	def resume(view)
		#Reset status text after tool has been temporarily deactivated
		Sketchup::set_status_text(@status_text, SB_PROMPT)
	end#def
	
	def draw(view)
		#Updates the view when necessary. Outlines input point and adds temporary guidelines
		#Achorpoint
		@prem_point.draw(view) if(@prem_point.valid? and@prem_point.display?)
		#Start1 and line to anchorpoint
		if(@deux_point.valid?)

			#Draw point
			@deux_point.draw(view) if(@deux_point.display?)

		end
		#target1 and line to anchorpoint and start1
		if(@trois_point.valid?)
			#Draw point
			@trois_point.draw(view) if(@trois_point.display?)
		end
		if(@quatre_point.valid?)
			#Draw point
			@quatre_point.draw(view) if(@quatre_point.display?)
		end
		if(@cinq_point.valid?)
			#Draw point
			@cinq_point.draw(view) if(@cinq_point.display?)
		end
		if(@six_point.valid?)
			#Draw point
			@six_point.draw(view) if(@six_point.display?)
		end
		if(@sept_point.valid?)
			#Draw point
			@sept_point.draw(view) if(@sept_point.display?)
		end
		if(@huit_point.valid?)
			#Draw point
			@huit_point.draw(view) if(@huit_point.display?)
		end
		if(@neuf_point.valid?)
			#Draw point
			@neuf_point.draw(view) if(@neuf_point.display?)
		end
		if(@dix_point.valid?)
			#Draw point
			@dix_point.draw(view) if(@dix_point.display?)
		end
		if(@onze_point.valid?)
			#Draw point
			@onze_point.draw(view) if(@onze_point.display?)
		end		
		if(@douze_point.valid?)
			#Draw point
			@douze_point.draw(view) if(@douze_point.display?)
		end	
		end#def
	
	def onMouseMove(flags, x, y, view)
	
	
		#Find points when hovering
		if(@etat == 0)
			#Anchorpoint
						
			@ip.pick view, x, y
			if( @ip != @prem_point )
				#Input point has moved
				#Update view
				view.invalidate
				#Set anchorpoint to current hovered point
				@prem_point.copy! @ip
			end#if
			
		elsif(@etat == 1)
			
			
			@ip.pick view, x, y, @prem_point
			if( @ip != @deux_point )
				#Input point has moved
				#Update view
				view.invalidate
				 #Set start1 point to current hovered point
				@deux_point.copy! @ip
			end#if
		
		elsif(@etat == 2)
			
			@ip.pick view, x, y, @deux_point
			if( @ip != @trois_point )
				#Input point has moved
				
				#Snap to radius and edge/c-line
				#(please please please, add this to the native Sketchup rotate tool)
				#Flag that changes tooltip
				smartEdgeSnap = false
				
				#Update view
				view.invalidate
				#Set target1 point to current hovered point
				@trois_point.copy! @ip
			end#if
			
			elsif(@etat == 3)
			
			@ip.pick view, x, y, @trois_point
			if( @ip != @quatre_point )
				#Input point has moved
				
				smartEdgeSnap = false
				
				#Update view
				view.invalidate
				#Set target1 point to current hovered point
				@quatre_point.copy! @ip
			end#if
				
			elsif(@etat == 4)
			
			@ip.pick view, x, y, @quatre_point
			if( @ip != @cinq_point )
				#Input point has moved
				
				smartEdgeSnap = false
				
				#Update view
				view.invalidate
				#Set target1 point to current hovered point
				@cinq_point.copy! @ip
			end#if		

			elsif(@etat == 5)
			
			@ip.pick view, x, y, @cinq_point
			if( @ip != @six_point )
				#Input point has moved
				
				smartEdgeSnap = false
				
				#Update view
				view.invalidate
				#Set target1 point to current hovered point
				@six_point.copy! @ip
			end#if
			
			elsif(@etat == 6)
			
			@ip.pick view, x, y, @six_point
			if( @ip != @sept_point )
				#Input point has moved
				
				smartEdgeSnap = false
				
				#Update view
				view.invalidate
				#Set target1 point to current hovered point
				@sept_point.copy! @ip
			end#if			
	
			elsif(@etat == 7)
			
			@ip.pick view, x, y, @sept_point
			if( @ip != @huit_point )
				#Input point has moved
				
				smartEdgeSnap = false
				
				#Update view
				view.invalidate
				#Set target1 point to current hovered point
				@huit_point.copy! @ip
			end#if	

			elsif(@etat == 8)
			
			@ip.pick view, x, y, @huit_point
			if( @ip != @neuf_point )
				#Input point has moved
				
				smartEdgeSnap = false
				
				#Update view
				view.invalidate
				#Set target1 point to current hovered point
				@neuf_point.copy! @ip
			end#if	

			elsif(@etat == 9)
			
			@ip.pick view, x, y, @neuf_point
			if( @ip != @dix_point )
				#Input point has moved
				
				smartEdgeSnap = false
				
				#Update view
				view.invalidate
				#Set target1 point to current hovered point
				@dix_point.copy! @ip
			end#if	

			elsif(@etat == 10)
			
			@ip.pick view, x, y, @dix_point
			if( @ip != @onze_point )
				#Input point has moved
				
				smartEdgeSnap = false
				
				#Update view
				view.invalidate
				#Set target1 point to current hovered point
				@onze_point.copy! @ip
			end#if	

			elsif(@etat == 11)
			
			@ip.pick view, x, y, @onze_point
			if( @ip != @douze_point )
				#Input point has moved
				
				smartEdgeSnap = false
				
				#Update view
				view.invalidate
				#Set target1 point to current hovered point
				@douze_point.copy! @ip
			end#if	

			
		end#if elsif
		

	end#def
	
	def onLButtonDown(flags, x, y, view)
	    

		model = Sketchup.active_model # Open model
		entities = model.entities # All entities in model
		selection = model.selection # Current selection

		#pose un point de construction
		#Sketchup.active_model.active_entities.add_cpoint(@ip.position) ;
		
		if(@etat == 0)
			#Select anchorpoint
			#@prem_point.pick view, x, y
			if(@prem_point.valid?)
			
			  ip = view.inputpoint x,y
			  point1 = ip.position
    
				@etat=1
				@status_text = "2nd point, ESC to reset, SPACE to finish."#first status text defined in reset()
				Sketchup::set_status_text(@status_text, SB_PROMPT)
			end#if
			
		elsif(@etat == 1)
			#Select startpoint 1
			if(@deux_point.valid?)

			  ip = view.inputpoint x,y
			  point2 = ip.position
  			
				@etat=2
				@status_text = "3rd point, ESC to reset, SPACE to finish."
				Sketchup::set_status_text(@status_text, SB_PROMPT)
			end#if
			
		elsif(@etat == 2)
			#Select targetpoint 1 and set yaw and pitch for selection
			if(@trois_point.valid?)
			
			  ip = view.inputpoint x,y
			  point3 = ip.position
			  
				@etat=3
				@status_text = "4th point, ESC to reset, SPACE to finish."
				Sketchup::set_status_text(@status_text, SB_PROMPT)
			end#if
	
			elsif(@etat == 3)
			#Select targetpoint 1 and set yaw and pitch for selection
			if(@quatre_point.valid?)
			
				ip = view.inputpoint x,y
				point4 = ip.position
			  
				@etat=4
				@status_text = "5th point, ESC to reset, SPACE to finish."
				Sketchup::set_status_text(@status_text, SB_PROMPT)
			end#if
	
			elsif(@etat == 4)
			#Select targetpoint 1 and set yaw and pitch for selection
			if(@cinq_point.valid?)
			
				ip = view.inputpoint x,y
				point5 = ip.position
			  
				@etat=5
				@status_text = "6th point, ESC to reset, SPACE to finish."
				Sketchup::set_status_text(@status_text, SB_PROMPT)
			end#if

			elsif(@etat == 5)
			#Select targetpoint 1 and set yaw and pitch for selection
			if(@six_point.valid?)
			
				ip = view.inputpoint x,y
				point6 = ip.position
			  
				@etat=6
				@status_text = "7th point, ESC to reset, SPACE to finish."
				Sketchup::set_status_text(@status_text, SB_PROMPT)				
#				pour finir la saisie automatiquement
#				result = Sketchup.send_action "selectSelectionTool:"
			end#if
			
			elsif(@etat == 6)
			#Select targetpoint 1 and set yaw and pitch for selection
			if(@sept_point.valid?)
			
				ip = view.inputpoint x,y
				point7 = ip.position
			  
				@etat=7
				@status_text = "8th point, ESC to reset, SPACE to finish."
				Sketchup::set_status_text(@status_text, SB_PROMPT)				
#				pour finir la saisie automatiquement
#				result = Sketchup.send_action "selectSelectionTool:"
			end#if

			elsif(@etat == 7)
			#Select targetpoint 1 and set yaw and pitch for selection
			if(@huit_point.valid?)
			
				ip = view.inputpoint x,y
				point8 = ip.position
			  
				@etat=8
				@status_text = "9th point, ESC to reset, SPACE to finish."
				Sketchup::set_status_text(@status_text, SB_PROMPT)				
#				pour finir la saisie automatiquement
#				result = Sketchup.send_action "selectSelectionTool:"
			end#if

			elsif(@etat == 8)
			#Select targetpoint 1 and set yaw and pitch for selection
			if(@neuf_point.valid?)
			
				ip = view.inputpoint x,y
				point9 = ip.position
			  
				@etat=9
				@status_text = "10th point, ESC to reset, SPACE to finish."
				Sketchup::set_status_text(@status_text, SB_PROMPT)				
#				pour finir la saisie automatiquement
#				result = Sketchup.send_action "selectSelectionTool:"
			end#if
		
			elsif(@etat == 9)
			#Select targetpoint 1 and set yaw and pitch for selection
			if(@dix_point.valid?)
			
				ip = view.inputpoint x,y
				point10 = ip.position
			  
				@etat=10
			@status_text = "11th point, ESC to reset, SPACE to finish."
				Sketchup::set_status_text(@status_text, SB_PROMPT)				
#				pour finir la saisie automatiquement
#				result = Sketchup.send_action "selectSelectionTool:"
			end#if

			elsif(@etat == 10)
			#Select targetpoint 1 and set yaw and pitch for selection
			if(@onze_point.valid?)
			
				ip = view.inputpoint x,y
				point11 = ip.position
			  
				@etat=11
				@status_text = "SPACE to finish."
				Sketchup::set_status_text(@status_text, SB_PROMPT)				
#				pour finir la saisie automatiquement
#				result = Sketchup.send_action "selectSelectionTool:"
			end#if
			
		end#if elsif
		
	end#def

#dans deactivate on met ce qui doit se faire quand l'outil est desactiv
def deactivate(view)

	model = Sketchup.active_model # Open model
	definitions = model.definitions
	entities = model.entities
	
	#######################################

# Create
@multdim= Inputbox.new("MultiDim")

# Load
@multdim.load
if @multdim.prompts.empty?
  # Build Inputbox
  @multdim.add("distance dim to points (m): ", [1, 2, 3, 4, 5, 6, 7, 8, 9, 10] )
end

# Display
# returns an Array of values
values = @multdim.show

# Persistent Storage
@multdim.save

trait_rapp = @multdim["distance dim to points (m): "]
		
#conversion texte
trait_rapp = trait_rapp.to_s
	
	#pour rafraichir l'ecran
	draw(view)
	
	#ouverture des tableaux de coordonnees	
	x = Array.new
	y = Array.new
	z = Array.new
	pt = Array.new
	distance = Array.new
	rot = Array.new

#recuperation des coordonnes des points dans des tableaux
	prem_point= @prem_point.position.to_a
	x[1] = prem_point[0].to_f
	y[1] = prem_point[1].to_f
	z[1] = prem_point[2].to_f
	
	deux_point= @deux_point.position.to_a
	x[2] = deux_point[0].to_f
	y[2] = deux_point[1].to_f
	z[2] = deux_point[2].to_f
	
	trois_point= @trois_point.position.to_a
	x[3] = trois_point[0].to_f
	y[3] = trois_point[1].to_f
	z[3] = trois_point[2].to_f

	quatre_point= @quatre_point.position.to_a
	x[4] = quatre_point[0].to_f
	y[4] = quatre_point[1].to_f
	z[4] = quatre_point[2].to_f
	
	cinq_point= @cinq_point.position.to_a
	x[5] = cinq_point[0].to_f
	y[5] = cinq_point[1].to_f
	z[5] = cinq_point[2].to_f

	six_point= @six_point.position.to_a
	x[6] = six_point[0].to_f
	y[6] = six_point[1].to_f
	z[6] = six_point[2].to_f
	
	sept_point= @sept_point.position.to_a
	x[7] = sept_point[0].to_f
	y[7] = sept_point[1].to_f
	z[7] = sept_point[2].to_f

	huit_point= @huit_point.position.to_a
	x[8] = huit_point[0].to_f
	y[8] = huit_point[1].to_f
	z[8] = huit_point[2].to_f

	neuf_point= @neuf_point.position.to_a
	x[9] = neuf_point[0].to_f
	y[9] = neuf_point[1].to_f
	z[9] = neuf_point[2].to_f

	dix_point= @dix_point.position.to_a
	x[10] = dix_point[0].to_f
	y[10] = dix_point[1].to_f
	z[10] = dix_point[2].to_f

	onze_point= @onze_point.position.to_a
	x[11] = onze_point[0].to_f
	y[11] = onze_point[1].to_f
	z[11] = onze_point[2].to_f

	douze_point= @douze_point.position.to_a
	x[12] = douze_point[0].to_f
	y[12] = douze_point[1].to_f
	z[12] = douze_point[2].to_f
	
	#cree des points 3d sur les points cliqus
	for i in (1..12)
	pt[i] = Geom::Point3d.new(x[i],y[i],z[i])
	end #for i in (1..12)
	
	#designation du composant cotation
	ref = "cotation_01.skp" if trait_rapp == "1"
	ref = "cotation_02.skp" if trait_rapp == "2"
	ref = "cotation_03.skp" if trait_rapp == "3"
	ref = "cotation_04.skp" if trait_rapp == "4"
	ref = "cotation_05.skp" if trait_rapp == "5"
	ref = "cotation_06.skp" if trait_rapp == "6"
	ref = "cotation_07.skp" if trait_rapp == "7"
	ref = "cotation_08.skp" if trait_rapp == "8"
	ref = "cotation_09.skp" if trait_rapp == "9"
	ref = "cotation_10.skp" if trait_rapp == "10"

	path = Sketchup.find_support_file ref, "plugins/mult_dim_tool/"
	comp = definitions.load path	
	
#pour tous les intervalles
for i in (1..10)
	distance[i] = pt[i+1].distance pt[i]
	
	#si 2 points superposs
#	if distance[i].abs ==0
#	Fail
#	end

	#0.1 m minimum entre les points, en pouces
	if distance[i].abs <3.937 and distance[i] != 0
	UI.messagebox "2 points too close"
	Fail
	end #if distance[i].a
	
	#dans le plan horizontal seulement
	if (z[i+1]-z[i]).abs >0.01
	UI.messagebox "points must be in the same horizontal plan"
	Fail
	end #if (x[i+1]-x[i]).abs...
	

	#suivant axes principaux seulement
	#dans l'espace
#	if (x[i+1]-x[i]).abs >0.01 and (y[i+1]-y[i]).abs >0.01 and (z[i+1]-z[i]).abs >0.01
#	UI.messagebox "points #{i} and #{i+1} dont' follow main axes"
#	Fail
#	end #if (x[i+1]-x[i]).abs...
	#dans plan XY
#	if (x[i+1]-x[i]).abs >0.01 and (y[i+1]-y[i]).abs >0.01 and (z[i+1]-z[i]).abs <0.01
#	UI.messagebox "points #{i} and #{i+1} dont' follow main axes"
#	Fail
#	end
	#dans plan YZ
#	if (z[i+1]-z[i]).abs >0.01 and (y[i+1]-y[i]).abs >0.01 and (x[i+1]-x[i]).abs <0.01
#	UI.messagebox "points #{i} and #{i+1} dont' follow main axes"
#	Fail
#	end	
	#dans plan XZ
#	if (z[i+1]-z[i]).abs >0.01 and (x[i+1]-x[i]).abs >0.01 and (y[i+1]-y[i]).abs <0.01
#	UI.messagebox "points #{i} and #{i+1} dont' follow main axes"
#	Fail
#	end	
	
	#mise a l'echelle de la cotation unite, point de depart et coeff dans 3 directions
	echelle = Geom::Transformation.scaling pt[i],distance[i].abs/39.37,1,1
	
	#si 2 points suiv axe rouge positif
if (y[i+1]-y[i]).abs <0.01 and x[i+1]>x[i] 
	rot[i] = 0
	
	#si 2 points suiv axe rouge negatif
	elsif (y[i+1]-y[i]).abs <0.01 and x[i+1]<x[i] 
	rot[i] = 3.1416

	#si 2 points suiv axe vert positif
	elsif (x[i+1]-x[i]).abs <0.01 and y[i+1]>y[i]
	rot[i] =  1.5708
	
	#si 2 points suiv axe vert negatif
	elsif (x[i+1]-x[i]).abs <0.01 and y[i+1]<y[i] 
	rot[i] =  4.7124
 	
	#1er cadran
	elsif x[i+1]>x[i] and y[i+1]>y[i] 
	rot[i] = Math.atan((y[i+1]-y[i])/(x[i+1]-x[i]))
	
	#2e cadran
	elsif x[i+1]<x[i] and y[i+1]>y[i]
	rot[i] = 3.1415-Math.atan(((y[i+1]-y[i])).abs/((x[i+1]-x[i])).abs)

	#3e cadran
	elsif x[i+1]<x[i] and y[i+1]<y[i]
	rot[i] = 4.7124-Math.atan(((y[i+1]-y[i])).abs/((x[i+1]-x[i])).abs)

	#4e cadran
	elsif x[i+1]>x[i] and y[i+1]<y[i]
	rot[i] = 6.2832-Math.atan(((y[i+1]-y[i])).abs/((x[i+1]-x[i])).abs)

	
end #if ...	


	puts i
	puts rot[i]
	
	
	rotation =  Geom::Transformation.rotation pt[i], [0,0,1], rot[i]
	
	#insere le composant au point de depart de la cote
	inst = entities.add_instance comp, pt[i]
	#combine les transformations
	transftotal = rotation*echelle

	#le fait tourner et le met a l'echelle
	inst.transform!(transftotal)
	
end #for i in (1..10)
	

end #def	
end#class

end#module


